"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _postcss = require("postcss");

var _postcss2 = _interopRequireDefault(_postcss);

var _caniuseApi = require("caniuse-api");

var _features = require("./features");

var _features2 = _interopRequireDefault(_features);

var _featuresActivationMap = require("./features-activation-map");

var _featuresActivationMap2 = _interopRequireDefault(_featuresActivationMap);

var plugin = _postcss2["default"].plugin("postcss-cssnext", function (options) {
  options = _extends({
    features: {}
  }, options);

  var features = options.features;

  // propagate browsers option to autoprefixer
  if (features.autoprefixer !== false) {
    features.autoprefixer = _extends({
      browsers: features.autoprefixer && features.autoprefixer.browsers ? features.autoprefixer.browsers : options.browsers
    }, features.autoprefixer || {});

    // autoprefixer doesn't like an "undefined" value. Related to coffee ?
    if (features.autoprefixer.browsers === undefined) {
      delete features.autoprefixer.browsers;
    }
  }

  var processor = (0, _postcss2["default"])();

  // features
  Object.keys(_features2["default"]).forEach(function (key) {
    // feature is auto enabled if: not disable && (enabled || no data yet ||
    // !supported yet)
    if (
    // feature is not disabled
    features[key] !== false && (
    // feature is enabled
    features[key] === true ||

    // feature don't have any browsers data (yet)
    _featuresActivationMap2["default"][key] === undefined ||

    // feature is not yet supported by the browsers scope
    _featuresActivationMap2["default"][key] && _featuresActivationMap2["default"][key][0] && !(0, _caniuseApi.isSupported)(_featuresActivationMap2["default"][key][0], options.browsers))) {
      var _plugin = _features2["default"][key](typeof features[key] === "object" ? _extends({}, features[key]) : undefined);
      processor.use(_plugin);
    }
  });

  return processor;
});

// according to the way babel transpile es6 module
// we cannot use the following syntax to export features
//
// export { libraryFeatures as features }
//
// babel only add `module.exports = exports["default"];` if there is only one
// thing exported
// so we add `features` as a plugin property
plugin.features = _features2["default"];

exports["default"] = plugin;
module.exports = exports["default"];
// options.browsers is deliberately undefined by default to inherit
// browserslist default behavior